Bug 484680 - /usr/bin/rhn-config-tnsnames.pl not needed in /etc/sudoers
/usr/bin/rhn-config-tnsnames.pl not needed in /etc/sudoers
Status: CLOSED CURRENTRELEASE
Product: Red Hat Satellite 5
Classification: Red Hat
Component: Server (Show other bugs)
530
All Linux
low Severity medium
: ---
: ---
Assigned To: Jan Pazdziora
wes hayutin
:
Depends On:
Blocks: 457079
  Show dependency treegraph
 
Reported: 2009-02-09 09:52 EST by Jan Pazdziora
Modified: 2009-09-10 15:11 EDT (History)
2 users (show)

See Also:
Fixed In Version: sat530
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-09-10 15:11:33 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Pazdziora 2009-02-09 09:52:25 EST
Description of problem:

The default installation of Satellite 5.3.0 adds /usr/bin/rhn-config-tnsnames.pl to alias INSTALL_RHN in /etc/sudoers.

I've grepped Spacewalk source and rhn-config-tnsnames appears to be called in two places -- in spacewalk/setup/lib/Spacewalk/Setup.pm, and in web/modules/rhn/RHN/SatInstall.pm. That Spacewalk::Setup is being used by root, so no sudo is needed (and called) there. That RHN::SatInstall calls

sub write_tnsnames {
  my $class = shift;
  my $sid = shift;
  my $addresses = shift;

  my @options;

  foreach my $line (@{$addresses}) {
    push @options, join(",", @{$line}{qw/protocol host port/});
  }

  my @opt_strings = map { "--address=$_" } @options;

  my $ret = system("/usr/bin/sudo", "/usr/bin/rhn-config-tnsnames.pl",
                   "--target=/etc/tnsnames.ora", "--sid=$sid", @opt_strings);

  if ($ret) {
    throw 'There was a problem updating the tnsnames.ora file.  '
      . 'See the webserver error log for details.';
  }

  return;
}

But the function write_tnsnames is not used in the whole Spacewalk codebase. Therefore I assume it is dead code which can be removed, and so can /usr/bin/rhn-config-tnsnames.pl from /etc/sudoers.

Note: I did this scan through our code to figure out if there are some commands that need additional SELinux treatment.

Version-Release number of selected component (if applicable):

Satellite-5.3.0-RHEL5-re20090206.1

How reproducible:

Deterministic.

Steps to Reproduce:
1. Install Satellite 5.3.0.
2. Look into /etc/sudoers.
  
Actual results:

/usr/bin/rhn-config-tnsnames.pl is there.

Expected results:

/usr/bin/rhn-config-tnsnames.pl is not there and Satellite continues to work OK.

Additional info:
Comment 1 Jan Pazdziora 2009-02-10 07:25:20 EST
The proposed change is to remove the INSTALL_RHN section and merge whatever needs to be there to CONFIG_RHN. The proposed sudoers.rhn is below. I've tested that with this, the Satellite/Spacewalk works and runs external commands fine.

## RHN specifics ##
Cmnd_Alias CONFIG_RHN = /usr/sbin/rhn-sat-restart-silent,\
                        /usr/bin/rhn-config-satellite.pl,\
                        /usr/bin/rhn-satellite-activate,\
                        /usr/bin/rhn-bootstrap,\
                        /usr/bin/rhn-ssl-tool,\
                        /usr/bin/rhn-ssl-dbstore,\
                        /usr/bin/rhn-load-ssl-cert.pl,\
                        /etc/rc.d/np.d/step Monitoring install,\
                        /etc/rc.d/np.d/step MonitoringScout install,\
                        /etc/rc.d/np.d/step Monitoring uninstall,\
                        /etc/rc.d/np.d/step MonitoringScout uninstall,\
                        /sbin/service Monitoring restart,\
                        /sbin/service MonitoringScout restart,\
                        /sbin/service taskomatic restart

# The CONFIG_RHN commands are required for reconfiguration of a
# running RHN Satellite.  They should be enabled for proper operation
# of the RHN Satellite.
apache  ALL=(root)      NOPASSWD: CONFIG_RHN
tomcat  ALL=(root)      NOPASSWD: CONFIG_RHN

# These two directives allow tomcat and apache to invoke CONFIG_RHN
# commands via sudo even without a real tty
Defaults:tomcat !requiretty
Defaults:apache !requiretty
Comment 2 Clifford Perry 2009-02-10 12:05:39 EST
This is a throw back from the old Installer - where we had command line install laid down packages. The WebUI then went through configuration/installation of Satellite to get it running, with many many steps, unlike the new WebUI portion that just asks for Username/password to be created for Sat Admin account. 

Cliff.
Comment 3 Jan Pazdziora 2009-02-11 02:25:56 EST
Reassigning to myself as the bugzillas are not tracked against the SELinux feature.
Comment 4 Jan Pazdziora 2009-02-11 02:28:01 EST
The previous comment should have been "are *now*".
Comment 5 Jan Pazdziora 2009-02-17 05:18:29 EST
Committed to Spacewalk repo, 78a1de12fd2d22a652924586dea1e76bb11c1578 and 2ac4bf843521144a002c9d9caafec83908292512.
Comment 6 Jan Pazdziora 2009-02-24 07:30:48 EST
With compose Satellite-5.3.0-RHEL5-re20090220.1 available, moving ON_QA.
Comment 7 wes hayutin 2009-02-25 14:04:01 EST
[root@grandprix ~]# cat /etc/sudoers | grep /usr/bin/rhn-config-tnsnames.pl
[root@grandprix ~]# 

verified 
 Satellite-5.3.0-RHEL5-re20090220.1-i386-embedded-oracle.iso
Comment 8 Miroslav Suchý 2009-08-26 05:28:46 EDT
[root@xen5 ~]# grep rhn-config-tnsnames.pl /etc/sudoers
[root@xen5 ~]#

satellite works fine

verified in stage on xen5
Comment 9 Brandon Perkins 2009-09-10 15:11:33 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHEA-2009-1434.html

Note You need to log in before you can comment on or make changes to this bug.